/**
 * 
 */
package org.processmining.plugins.log.transitionchecker;

import java.util.List;
import java.util.Set;

/**
 * @author arya
 * @email arya.adriansyah@gmail.com
 * @version Apr 9, 2009
 */
public interface LifecycleTransitionChecker {
	public static final int ALLLIFECYCLETRANSITION = -1;
	public static final int SCHEDULE = 0;
	public static final int ASSIGN = 1;
	public static final int WITHDRAW = 2;
	public static final int REASSIGN = 3;
	public static final int START = 4;
	public static final int SUSPEND = 5;
	public static final int RESUME = 6;
	public static final int PI_ABORT = 7;
	public static final int ATE_ABORT = 8;
	public static final int COMPLETE = 9;
	public static final int AUTOSKIP = 10;
	public static final int MANUALSKIP = 11;
	public static final int UNKNOWN = 12;

	public Set<Integer> getAvailableLifecycleTransitions();

	public List<Integer> getAvailableTransitionsFrom(int currLifecycleTransition);

	public List<Integer> getAvailableTransitionsTo(int currLifecycleTransition);

	public boolean isValid(int fromLifecycleTransition, int toLifecycleTransition);

	public int getIndexOfLifecycleTransitionString(String lifecycleTransition);
}
